/* in functions that do not allocate memory on the OCaml heap, it is not necessary to mark parameters with CAMLparam,
   since in such functions it is not possible that the OCaml garbage collector is called */

#include "smath.h"
//#include <caml/mlvalues.h>
#include <caml/memory.h>


#define TO_INTREF(x) ((INTERVAL *)&Field(x, 0))
#define TO_INTV(x) (*(TO_INTREF(x)))
#define ALLOC_INTV alloc_small(sizeof(double)*2, Double_array_tag);


/*typedef struct inter{
double lo;
double hi;
}zero; */

//zero->lo=0.0;zero->hi=0.0;
value narrow_add_(value i1, value i2, value i3) {
  return Val_int(narrow_add(TO_INTREF(i1), TO_INTREF(i2), TO_INTREF(i3)));
}

 value narrow_square_(value i1, value i2) {
  return Val_int(narrow_square(TO_INTREF(i1), TO_INTREF(i2)));
}

value narrow_mul_(value i1, value i2, value i3) {
  return Val_int(narrow_mul(TO_INTREF(i1), TO_INTREF(i2), TO_INTREF(i3)));
}

value narrow_pow_odd_(value i1, value i2, value i3) {
  return Val_int(narrow_pow_odd(TO_INTREF(i1), TO_INTREF(i2), TO_INTREF(i3)));
}

value  narrow_pow_even_(value i1, value i2, value i3) {
  return Val_int(narrow_pow_even(TO_INTREF(i1), TO_INTREF(i2), TO_INTREF(i3)));
}

value narrow_eq_(value i1) {
     INTERVAL zero;
     zero.lo=0.0;
     zero.hi=0.0;
  return Val_int(narrow_eq(TO_INTREF(i1),&zero));
}

value narrow_le_(value i1) {
   INTERVAL zero;
   zero.lo=0.0;
   zero.hi=0.0;
  return Val_int(narrow_le(TO_INTREF(i1),&zero ));
}
value narrow_ge_(value i1) {
  INTERVAL zero;
  zero.lo=0.0;
  zero.hi=0.0;
  return Val_int(narrow_le(&zero,TO_INTREF(i1)));
}
value narrow_gt_(value i1) {
  INTERVAL zero;
  zero.lo=0.0;
  zero.hi=0.0;
  return Val_int(narrow_lt(&zero,TO_INTREF(i1)));
}
value narrow_ne_(value i1) {
INTERVAL zero;
   zero.lo=0.0;
zero.hi=0.0;
  return Val_int(narrow_ne(TO_INTREF(i1), &zero));
}

value narrow_lt_(value i1) {
   INTERVAL zero;
   zero.lo=0.0;
   zero.hi=0.0;
  return Val_int(narrow_lt(TO_INTREF(i1),&zero));
}

value narrow_sin_(value i1, value i2) {
  return Val_int(narrow_sin(TO_INTREF(i1), TO_INTREF(i2)));
}

value narrow_cos_(value i1, value i2) {
  return Val_int(narrow_cos(TO_INTREF(i1), TO_INTREF(i2)));
}

value narrow_exp_(value i1, value i2) {
  return Val_int(narrow_exp(TO_INTREF(i1), TO_INTREF(i2)));
}

value addIII_(value i1, value i2) {
  CAMLparam2(i1, i2);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= addIII(TO_INTV(i1), TO_INTV(i2));
  CAMLreturn(result);
}



value subIII_(value i1, value i2) {
  CAMLparam2(i1, i2);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= subIII(TO_INTV(i1), TO_INTV(i2));
  CAMLreturn(result);
}

value mulIII_(value i1, value i2) {
  CAMLparam2(i1, i2);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= mulIII(TO_INTV(i1), TO_INTV(i2));
  CAMLreturn(result);
}

value divIII_(value i1, value i2) {
  CAMLparam2(i1, i2);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= divIII(TO_INTV(i1), TO_INTV(i2));
  CAMLreturn(result);
}

value intersectIII_(value i1, value i2) {
  CAMLparam2(i1, i2);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= intersectIII(TO_INTV(i1), TO_INTV(i2));
  CAMLreturn(result);
}

value unionIII_(value i1, value i2) {
  CAMLparam2(i1, i2);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= unionIII(TO_INTV(i1), TO_INTV(i2));
  CAMLreturn(result);
}

value maxIII_(value i1, value i2) {
  CAMLparam2(i1, i2);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= maxIII(TO_INTV(i1), TO_INTV(i2));
  CAMLreturn(result);
}

value minIII_(value i1, value i2) {
  CAMLparam2(i1, i2);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= minIII(TO_INTV(i1), TO_INTV(i2));
  CAMLreturn(result);
}
value negII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= negII(TO_INTV(i1));
  CAMLreturn(result);
}

value sqrtII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= sqrtII(TO_INTV(i1));
  CAMLreturn(result);
}

value squareII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= squareII(TO_INTV(i1));
  CAMLreturn(result);
}
value absII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= absII(TO_INTV(i1));
  CAMLreturn(result);
}
value sgnII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= sgnII(TO_INTV(i1));
  CAMLreturn(result);
}
value floorII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= floorII(TO_INTV(i1));
  CAMLreturn(result);
}
value ceilII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= ceilII(TO_INTV(i1));
  CAMLreturn(result);
}
value two_to_nDI_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= two_to_nDI(i1);
  CAMLreturn(result);
}
value expII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= expII(TO_INTV(i1));
  CAMLreturn(result);
}

value logII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= logII(TO_INTV(i1));
  CAMLreturn(result);
}
value tanII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= tanII(TO_INTV(i1));
  CAMLreturn(result);
}
value cosII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= cosII(TO_INTV(i1));
  CAMLreturn(result);
}
value sinII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= sinII(TO_INTV(i1));
  CAMLreturn(result);
}
value asinII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= asinII(TO_INTV(i1));
  CAMLreturn(result);
}
value acosII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= acosII(TO_INTV(i1));
  CAMLreturn(result);
}
value atanII_(value i1) {
  CAMLparam1(i1);
  CAMLlocal1(result);

  result= ALLOC_INTV;
  TO_INTV(result)= atanII(TO_INTV(i1));
  CAMLreturn(result);
}
